/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.records;


import com.tabajara.base.tables.Controlegrpacesso;
import com.tabajara.base.tables.interfaces.IControlegrpacesso;

import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record3;
import org.jooq.Row3;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ControlegrpacessoRecord extends UpdatableRecordImpl<ControlegrpacessoRecord> implements VertxPojo, Record3<Integer, Integer, Integer>, IControlegrpacesso {

    private static final long serialVersionUID = -540172462;

    /**
     * Setter for <code>public.controlegrpacesso.congrpid</code>.
     */
    @Override
    public ControlegrpacessoRecord setCongrpid(Integer value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>public.controlegrpacesso.congrpid</code>.
     */
    @Override
    public Integer getCongrpid() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>public.controlegrpacesso.fkconid</code>.
     */
    @Override
    public ControlegrpacessoRecord setFkconid(Integer value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>public.controlegrpacesso.fkconid</code>.
     */
    @Override
    public Integer getFkconid() {
        return (Integer) get(1);
    }

    /**
     * Setter for <code>public.controlegrpacesso.fkgrpid</code>.
     */
    @Override
    public ControlegrpacessoRecord setFkgrpid(Integer value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>public.controlegrpacesso.fkgrpid</code>.
     */
    @Override
    public Integer getFkgrpid() {
        return (Integer) get(2);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record3 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row3<Integer, Integer, Integer> fieldsRow() {
        return (Row3) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row3<Integer, Integer, Integer> valuesRow() {
        return (Row3) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return Controlegrpacesso.CONTROLEGRPACESSO.CONGRPID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field2() {
        return Controlegrpacesso.CONTROLEGRPACESSO.FKCONID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field3() {
        return Controlegrpacesso.CONTROLEGRPACESSO.FKGRPID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getCongrpid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component2() {
        return getFkconid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component3() {
        return getFkgrpid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getCongrpid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value2() {
        return getFkconid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value3() {
        return getFkgrpid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ControlegrpacessoRecord value1(Integer value) {
        setCongrpid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ControlegrpacessoRecord value2(Integer value) {
        setFkconid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ControlegrpacessoRecord value3(Integer value) {
        setFkgrpid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ControlegrpacessoRecord values(Integer value1, Integer value2, Integer value3) {
        value1(value1);
        value2(value2);
        value3(value3);
        return this;
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public void from(IControlegrpacesso from) {
        setCongrpid(from.getCongrpid());
        setFkconid(from.getFkconid());
        setFkgrpid(from.getFkgrpid());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public <E extends IControlegrpacesso> E into(E into) {
        into.from(this);
        return into;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached ControlegrpacessoRecord
     */
    public ControlegrpacessoRecord() {
        super(Controlegrpacesso.CONTROLEGRPACESSO);
    }

    /**
     * Create a detached, initialised ControlegrpacessoRecord
     */
    public ControlegrpacessoRecord(Integer congrpid, Integer fkconid, Integer fkgrpid) {
        super(Controlegrpacesso.CONTROLEGRPACESSO);

        set(0, congrpid);
        set(1, fkconid);
        set(2, fkgrpid);
    }

    public ControlegrpacessoRecord(io.vertx.core.json.JsonObject json) {
        this();
        fromJson(json);
    }
}
